//+------------------------------------------------------------------+
//|                                                     River.mq4 |
//|                      Copyright  2007, Alsin             |
//|                                       
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#include <stderror.mqh>
 
#define MAGICMA  20050610
 




//extern int    PCCi=35; //  CCI  
extern int    k=0;
extern double Lots               = 0.2;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
//extern double MovingPeriod       = 20;
//extern double Periodfast         = 6;
//extern double Periodslow         = 10;
//extern double MovingShift        = 0;
//extern double ndot               =18;
//extern double CountBars          =3000;
//extern double MovingPeriod1      = 3; 
extern double TrailingStop       = 0; 
//extern double TrailingStop1      = 0;
//extern double AtrPer             = 6;
//extern double MACDOpenLevel      = 3; 
extern double StopLoss           = 50;
extern double TakeProfit         = 300;
//extern double TimeFrame         = 60;
//extern double TimeFrame1        = 240;
//extern double optim              = -1.1;
//extern double optim1             = 0;
//extern double optim2             = 0;
//extern double optim3             = 0;
//extern int up_otkat              = 0;
//extern int level                 = 0;
//extern int forcelevel            = 0;
extern bool   SndMl              = false ;
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        
        }
      if(losses>1)
      { lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     k=0;
     }
     else k=0;
     
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
   
  }
//+------------------------------------------------------------------+
//|         .        |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double ma0, ma50,ma51,ma52;
   double ma1;
   double ma2, ma3, ma4, ma5, ma10,ma11,ma12,ma13,ma14,ma15,ma60,ma61,ma62,ma63,ma64,ma65;
   double mas8_1, mas8_0, maf2_1, maf2_0;
   double sar0;
   double sar1;
   double sar2;
   double sar3;
   double icc0;
   double icc1;
   double icc2;
   double icc_typ; 
   double macd0,macds0,macds1,macds2;
   double macd0_open, macd1_open;
   double macd1;
   double macd2;
   double force, force1;
   double ao;
   double stl,stl1, stl2, stl21; 
   double ao1;
  double adc,adc1,adc2,adc3,adp,adp1,adp2,adp3,adp4,adm,adm1,adm2,adm3;
   double st0,st1,st2, ss0,ss1,ss2;
   double c1, c, c2,c3,c4, cs,cs1,cs2,cs3 , cs4, cs5, l, l1, l2;
   double tr,tr1,tr2,tr3, t,t1,t2,t3; 
   double w01,w02,w11,w12,w_01,w_02,w_11,w_12 ;
   double ao2;
   double bu, bu1, bu2, bu3, bu4, bu5, be, be1, be2, be3, be4, be5, bo, bo1, bo2, bo3, bo4, bo5;
   double g, h, Zig, Zag ; 
   double rsi50, rsi51, rsi52;
   double bal1, bal, bal2, bal4, baup, baup1, baup2, baup4;
   double ma20, ma21, ma22, ma23, ma24, ma25;
   double acs, acs1, acs2;
   double ku1,ku2,km1,km2,kl1,kl2, ku0; 
   double LookingToSellBreakPIPs = 0, LookingToBuyBreakPIPs = 0, NotSoldYet = 1, 
NotBoughtYet = 1, MACD_Signal = 0, MACD_Main = 0, MACD_Main2 = 0, MACD_Main3 = 0, 
MACD_Main4 = 0, MACD_Main5 = 0,  MACD_MainPrev = 0, MACD_SignalPrev = 0;

double  MACD_Signal3 = 0, MACD_Mains = 0, MACD_Main2s = 0, MACD_Main3s = 0, 
MACD_Main4s = 0, MACD_Main5s = 0, MACD_MainPrevs = 0, MACD_SignalPrevs = 0, MACD0;
double e,e1,e2,el,el1,el2;
   
   int    res1, take;
   string sHeaderLetter;
   string sBodyLetter;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
   
   

  macd0=iMACD(NULL,0,12,26,7,PRICE_CLOSE,MODE_MAIN,0);
  macd1=iMACD(NULL,0,12,26,7,PRICE_CLOSE,MODE_MAIN,1);
  macd2=iMACD(NULL,0,12,26,7,PRICE_CLOSE,MODE_MAIN,2);
   
  macds0=iMACD(NULL,0,12,26,7,PRICE_CLOSE,MODE_SIGNAL,0);
  macds1=iMACD(NULL,0,12,26,7,PRICE_CLOSE,MODE_SIGNAL,1);
  macds2=iMACD(NULL,0,12,26,7,PRICE_CLOSE,MODE_SIGNAL,2);

ku0 =iCustom(NULL, 0, "Keltner Channel", 0, 0);	  
ku1 =iCustom(NULL, 0, "Keltner Channel", 0, 1);
ku2 =iCustom(NULL, 0, "Keltner Channel",0, 1);
km1 =iCustom(NULL, 0, "Keltner Channel",1,1 );	  
km2 =iCustom(NULL, 0, "Keltner Channel",1,2);		     
kl1 =iCustom(NULL, 0, "Keltner Channel",2,1);	
kl2 =iCustom(NULL, 0, "Keltner Channel",2,2);





e= iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_UPPER,0); 
e1=iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_UPPER,1);
e2=iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_UPPER,2); 

el= iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_LOWER,0); 
el1=iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_LOWER,1);
el2=iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_LOWER,2); 

     
  //----  1
  // if (ma5>=ma1 && ma3>=ma1 && ma4>=ma0 && ma2>=ma0) 
    
   // if (MathAbs(Open[1]-Close[1])> (Open[0]-ma0) && Open[0]<ma0 )
   // {
   // if (Open[0]> Zag && Zag>0)
   // if (MathAbs(be1)>MathAbs(bu1)&& bu1>0 && be1<0 && bu1*2>=MathAbs(be1)) 
  //  if (mas8_1>maf2_1 &&  mas8_0<maf2_0)// && macd0>macd1 && macd1>macd2) //&& bu2<0 && bu1>bu2 )//&& rsi50>50)// && rsi50>50)// && sar0<Open[0])// && icc1>0)// && force>0)//||
    if (High[1]>e1 && Low[1]>=e1 && macd1>macds1 && macd1>0.0003 && MathAbs(Open[1]-e1)>0.0002 && Open[0]>Open[1]&& (High[2]<=e1 || Low[2]<=e1))//&& (-Close[1])>MathAbs(Open[1]-High[1])) )//Close[1]>ku1 && Open[0]>ku0)// && adc1>adp1)// && adp1>adp4 && MathAbs(macd0)>0.0003 ))// && macd0<0)// && macds0<0 && macd2<=macds2 && macd1>macds1) // && t2<=tr2 && t1>tr1)
    //(macd0>0 && macd1>0 && ao>0 && sar0< Open[0] && icc0>1 && force>0))//---           && macd0_open>=-0.00005 && Close[0]>ma0))//||(mas8_1>maf2_1 && mas8_0<maf2_0 && sar0<Open[0]&& mas8_1<ma1 ))
   
   //((macd0>0 && (macd1<0||macd2<0) && MathAbs(macd0)>(MACDOpenLevel*Point)) && icc0>0&&(icc1<0 ||icc2<0)  && Open[0]>sar0 )//&& Open[0]>sar0 && sar0>sar1 && Open[0]>ma0 && icc>0))
     {
   if (OrdersTotal()<2)
    res1=OrderSend(Symbol(),OP_BUY,0.2,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",MAGICMA,0,Blue);
 //  Print("", bu1, be1);
   // up_otkat=0;   
   //   return;
    }  
 
 
 // if (macd0>0 && macd1>0 && macd2<=0 && bu>bu1) //&& bu2<0 && bu1>bu2 )//&& rsi50>50)// && rsi50>50)// && sar0<Open[0])// && icc1>0)// && force>0)//||
    //(macd0>0 && macd1>0 && ao>0 && sar0< Open[0] && icc0>1 && force>0))//---           && macd0_open>=-0.00005 && Close[0]>ma0))//||(mas8_1>maf2_1 && mas8_0<maf2_0 && sar0<Open[0]&& mas8_1<ma1 ))
   
   //((macd0>0 && (macd1<0||macd2<0) && MathAbs(macd0)>(MACDOpenLevel*Point)) && icc0>0&&(icc1<0 ||icc2<0)  && Open[0]>sar0 )//&& Open[0]>sar0 && sar0>sar1 && Open[0]>ma0 && icc>0))
 //    {
 //   res1=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,0,"",MAGICMA,0,Blue);
 //  Print(" macd", bu1, be1);
   // up_otkat=0;   
   //   return;
//    }  
 
 
 //  }
  //  if ((MathAbs(be1)>MathAbs(bu1)&& bu1>0 && be1<0 && bu1*2>=MathAbs(be1))//&& rsi50>50)// && rsi50>50)// && sar0<Open[0])// && icc1>0)// && force>0)//||
  //   {
   // res1=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,0,"",MAGICMA,0,Blue);
   //Print("     - ", icc1);
   // up_otkat=0;   
   //   return;
  //  }  
    
  // if (MACD_Main>0 && MACD_MainPrev<=0 && icc1<100  && icc1>-100 && MACD_Signal*MACD_Signals>0 &&  ((ao1>0.00050)||(ao1<-0.00150)))//&& rsi50>50)// && rsi50>50)// && sar0<Open[0])// && icc1>0)// && force>0)//||
  //   {
  //  res1=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,0,"",MAGICMA,0,Blue);
  // Print("   ", icc1);
   // up_otkat=0;   
   //   return;
  //  }  
  //   if (MACD_Mains>0 && MACD_MainPrevs<=0 && icc1<100  && icc1>-100 && MACD_Signal*MACD_Signals>0 && ((ao1>0.00050)||(ao1<-0.00150)))//&& rsi50>50)// && rsi50>50)// && sar0<Open[0])// && icc1>0)// && force>0)//||
  //   {
  //  res1=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,0,"",MAGICMA,0,Blue);
  // Print("   0",icc1);
   // up_otkat=0;   
   //   return;
   // }  
    
 //   for(int i=0;i<OrdersTotal();i++)
 //    {
 //     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        
  //    {
      //----  
     //----  1
  // if (ma5>=ma1 && ma3>=ma1 && ma4>=ma0 && ma2>=ma0) 
 //   if ( )//&& macd0_open > macd1_open)//---           && macd0_open>=-0.00005 && Close[0]>ma0))//||(mas8_1>maf2_1 && mas8_0<maf2_0 && sar0<Open[0]&& mas8_1<ma1 ))
   
   //((macd0>0 && (macd1<0||macd2<0) && MathAbs(macd0)>(MACDOpenLevel*Point)) && icc0>0&&(icc1<0 ||icc2<0)  && Open[0]>sar0 )//&& Open[0]>sar0 && sar0>sar1 && Open[0]>ma0 && icc>0))
//     {
  //  res1=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,0,"",MAGICMA,0,Blue);
  // Print("   ---  macd+icc");
   // up_otkat=0;   
   //   return;
  //  }  
  //   }
  //   }
  
  //  }
    
    
 // if ((ma0<ma3 && ma0<ma5 && mas8_1>maf2_1 && mas8_0<maf2_0 && Open[0]<ma0))//---      
   
//   //((macd0>0 && (macd1<0||macd2<0) && MathAbs(macd0)>(MACDOpenLevel*Point)) && icc0>0&&(icc1<0 ||icc2<0)  && Open[0]>sar0 )//&& Open[0]>sar0 && sar0>sar1 && Open[0]>ma0 && icc>0))
//     {
//    res1=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,0,"",MAGICMA,0,Blue);
//    up_otkat=1;  
  
//  take = MathRound((ma0-ma20)*10000/2);
  
//  if (ma20>ma21 && ma21>ma22 && ma22<ma23 && ma23<ma24 && ma24<ma25 && ma22<ma2 && ma23<ma3 && ma0>ma20 && (ma0-Open[0])*10000 >4  )//---      
   
   //((macd0>0 && (macd1<0||macd2<0) && MathAbs(macd0)>(MACDOpenLevel*Point)) && icc0>0&&(icc1<0 ||icc2<0)  && Open[0]>sar0 )//&& Open[0]>sar0 && sar0>sar1 && Open[0]>ma0 && icc>0))
     {
    if (take>5)
    {//res1=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,Ask+Point*take,"",MAGICMA,0,Blue);
    //Print("    ",take);

  //  up_otkat=1; 
    } 
  
  if (take<=5)
    {//res1=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,0,"",MAGICMA,0,Blue);
     //Print("     ");

//    up_otkat=1; 
    } 
  
   //   return;
    }  
       
//----
  
  
 // if (up_otkat>0 ) 
 //    if ( macd1>0 && Close[1]>ma1 && icc1>0 && sar2<Close[2] && sar1<Close[1])
 //     {res1=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,0,"",MAGICMA,0,Blue);
 //     up_otkat=0;
 //     } 
  
  
  
  
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  double ma0;
   double ma1;
   double ma2, ma3;
   double sar0;
   double sar1;
   double sar2;
   double sar3;
   double sar4;
   double icc0;
   double icc1;
   double icc2;
   double icc_typ; 
   double macd0;
   double macd1;
   double macd2, macd3;
   double macds0, macds1, macds2;
   double ao;
    double r,r1,r2,r3, c,c1,c2,c3, cs , cs1 , cs2, cs3, cs4;
   double bu, bu1, bu2, bu3, bu4, bu5, be, be1, be2, be3, be4, be5;
   double ao1;
   double ao2;
   double rsi50;
   double force, force1, force2, force3, force4, force5, force6;
   double mas8_1, mas8_2, maf2_1, maf2_2;
   int    res, b, ticket;
   string sHeaderLetter;
   string sBodyLetter;
   bool rtvl;
   double ku1,ku2,km1,km2,kl1,kl2, ku0; 
    double LookingToSellBreakPIPs = 0, LookingToBuyBreakPIPs = 0, NotSoldYet = 1, 
NotBoughtYet = 1, MACD_Signal = 0, MACD_Main = 0, MACD_Main2 = 0, MACD_Main3 = 0, 
MACD_Main4 = 0, MACD_Main5 = 0,  MACD_MainPrev = 0, MACD_SignalPrev = 0;

double  MACD_Signals = 0, MACD_Mains = 0, MACD_Main2s = 0, MACD_Main3s = 0, 
MACD_Main4s = 0, MACD_Main5s = 0, MACD_MainPrevs = 0, MACD_SignalPrevs = 0;
  
double w1,w2,w3, w4; 
 double e,e1,e2,el,el1,el2;  
   
//---- 
   if(Volume[0]>1) return;
//----  

	  
	  
   macd0=iMACD(NULL,0,12,26,7,PRICE_OPEN,MODE_MAIN,0);
   macd1=iMACD(NULL,0,12,26,7,PRICE_OPEN,MODE_MAIN,1);
   macd2=iMACD(NULL,0,12,26,7,PRICE_OPEN,MODE_MAIN,2);  
   macd3=iMACD(NULL,0,12,26,7,PRICE_OPEN,MODE_MAIN,3);  
   
   macds0=iMACD(NULL,0,12,26,7,PRICE_CLOSE,MODE_SIGNAL,0);
  macds1=iMACD(NULL,0,12,26,7,PRICE_CLOSE,MODE_SIGNAL,1);
  macds2=iMACD(NULL,0,12,26,7,PRICE_CLOSE,MODE_SIGNAL,2);




ku0 =iCustom(NULL, 0, "Keltner Channel", 0, 0);	  
ku1 =iCustom(NULL, 0, "Keltner Channel", 0, 1);
ku2 =iCustom(NULL, 0, "Keltner Channel",0, 1);
km1 =iCustom(NULL, 0, "Keltner Channel",1,1 );	  
km2 =iCustom(NULL, 0, "Keltner Channel",1,2);		     
kl1 =iCustom(NULL, 0, "Keltner Channel",2,1);	
kl2 =iCustom(NULL, 0, "Keltner Channel",2,2);

e= iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_UPPER,0); 
e1=iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_UPPER,1);
e2=iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_UPPER,2); 

el= iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_LOWER,0); 
el1=iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_LOWER,1);
el2=iEnvelopes(NULL, 0, 62,MODE_SMA,0,PRICE_CLOSE,0.05,MODE_LOWER,2); 


//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if( OrderSymbol()!=Symbol()) continue;//OrderMagicNumber()!=MAGICMA ||
      //----  
      if(OrderType()==OP_BUY)
        {
         if((kl2>e2 && kl1<=e1))//||(macd1>0.0009 && macd2>=macds2 && macds1<macds1))//(Close[1]<km1 && kl1<=e1)||&& macd0<0)//||(sar3>ma2 && sar3<Open[3] && sar2>Open[2] && sar1>Open[1] && sar0>Close[0]))
         rtvl=OrderClose(OrderTicket(),0.1,Bid,3,Lime);
         
        if(macd1>0.0009 && macd2>=macds2 && macd1<macds1)//(Close[1]<km1 && kl1<=e1)||&& macd0<0)//||(sar3>ma2 && sar3<Open[3] && sar2>Open[2] && sar1>Open[1] && sar0>Close[0]))
         {
         rtvl=OrderClose(OrderTicket(),0.1,Bid,3,Lime);
         } 
   if(OrderType()==OP_BUY)
        {
         if((kl2>e2 && kl1<=e1))//||(macd1>0.0009 && macd2>=macds2 && macds1<macds1))//(Close[1]<km1 && kl1<=e1)||&& macd0<0)//||(sar3>ma2 && sar3<Open[3] && sar2>Open[2] && sar1>Open[1] && sar0>Close[0]))
         rtvl=OrderClose(OrderTicket(),0.1,Bid,3,Lime);
         }
       // if(macd1>0.0009 && macd2>=macds2 && macd1<macds1)//(Close[1]<km1 && kl1<=e1)||&& macd0<0)//||(sar3>ma2 && sar3<Open[3] && sar2>Open[2] && sar1>Open[1] && sar0>Close[0]))
       //  {
       //  rtvl=OrderClose(OrderTicket(),0.1,Bid,3,Lime);
       //  }     
           // if(Close[2]> Close[3] && Close[2]> Close[4] && Close[2]> Close[5]&& Close[2]> Close[6] && Close[1]< Close[2] && Open[0]<Open[1])//||(sar3>ma2 && sar3<Open[3] && sar2>Open[2] && sar1>Open[1] && sar0>Close[0]))
        // {
        // rtvl=OrderClose(OrderTicket(),OrderLots(),Bid,3,Lime);
        // Print("    ");
        // }
         
        //  if(force2>force3 && force2>force4 && force2>force5 && force2>force6 && force1<force2 && force<=force1)//||(sar3>ma2 && sar3<Open[3] && sar2>Open[2] && sar1>Open[1] && sar0>Close[0]))
        // {
        // rtvl=OrderClose(OrderTicket(),OrderLots(),Bid,3,Lime);
        // Print("    ");
        // }
         
      //   else
      //   if (Close[1]>ma1 && Close[0]<ma0)
      //  {up_otkat=1;
      //   rtvl=OrderClose(OrderTicket(),OrderLots(),Bid,3,Lime);
        
      //   }  
            if ( SndMl == True && rtvl != False )
            {
            sHeaderLetter = "Operation CLOSE BUY at" + Symbol()+"";
            sBodyLetter = "Close order Buy at"+ Symbol() + " for " + DoubleToStr(Bid,4)+ ", and finish this Trade";
            sndMessage(sHeaderLetter, sBodyLetter);
            }
       //  break;
        
     // if (up_otkat>0)
      if(TrailingStop>0)  
             {                 
              if(Bid-OrderOpenPrice()>Point*TrailingStop)
                {
                if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                    return(0);
                    }
                }
              }
           break;
        }
     
   //  if (b>0) 
   //  {
   //  ticket=OrderSend(Symbol(),OP_SELL,1,Bid,3,Bid-StopLoss*Point,0,"My order #2",16384,0,Green);
     
   //    }

     
      if(OrderType()==OP_SELL) 
        {
      if(ao2<0 && ao1>0) rtvl=OrderClose(OrderTicket(),OrderLots(),Ask,3,Lime);
         if ( SndMl == True && rtvl != False ) 
         {
         sHeaderLetter = "Operation CLOSE SELL at" + Symbol()+"";
         sBodyLetter = "Close order Sell at"+ Symbol() + " for " + DoubleToStr(Ask,4)+ ", and finish this Trade";
         sndMessage(sHeaderLetter, sBodyLetter);
         }
        // break;
   //    if(TrailingStop>0)  
   //         {                 
   //           if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
   //             {
   //              if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
   //                {
   //                OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
   //                return(0);
   //               }
   //              }
   //         }
         break;
        }
     }
//----
  }
  
//--------------------------------------------------------------------
//        
//--------------------------------------------------------------------
void sndMessage(string HeaderLetter, string BodyLetter)
{
   int RetVal;
   SendMail( HeaderLetter, BodyLetter );
   RetVal = GetLastError();
   if (RetVal!= ERR_NO_MQLERROR) Print (",   : ", ErrorDescription(RetVal));
}
//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<25 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())<2) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+

